Loading...
Searching...
No Matches
casacore::MemoryStMan Class Reference
tables package (libcasa_tables) » DataMan_module

More...

`#include <MemoryStMan.h>`

## Public Member Functions

| MemoryStMan ()
| Create an Memory storage manager.
| MemoryStMan (const String &storageManagerName)
| Create an Memory storage manager with the given name.
| ~MemoryStMan ()
Public Member Functions inherited from casacore::MSMBase
| MSMBase ()
| Create a memory storage manager.
| MSMBase (const String &storageManagerName)
| Create a memory storage manager with the given name.
| MSMBase (const String &storageManagerName, const Record &)
virtual | ~MSMBase ()
virtual DataManager * | clone () const
| Clone this object.
virtual String | dataManagerType () const
| Get the type name of the data manager (i.e.
virtual String | dataManagerName () const
| Get the name given to this storage manager.
void | setHasPut ()
| Set the hasPut_p flag.
rownr_t | nrow () const
| Get the nr of rows in this storage manager.
virtual Bool | canAddRow () const
| Does the storage manager allow to add rows?
virtual Bool | canRemoveRow () const
| Does the storage manager allow to delete rows?
virtual Bool | canAddColumn () const
| Does the storage manager allow to add columns?
virtual Bool | canRemoveColumn () const
| Does the storage manager allow to delete columns?
Public Member Functions inherited from casacore::DataManager
| DataManager ()
| Default constructor.
virtual | ~DataManager ()
| DataManager (const DataManager &)=delete
| The copy constructor cannot be used for this base class.
DataManager & | operator= (const DataManager &)=delete
| Assignment cannot be used for this base class.
void | dataManagerInfo (Record &info) const
| Add SEQNR and SPEC (the DataManagerSpec subrecord) to the info.
virtual Record | dataManagerSpec () const
| Return a record containing data manager specifications.
virtual Record | getProperties () const
| Get data manager properties that can be modified.
virtual void | setProperties (const Record &spec)
| Modify data manager properties given in record fields.
virtual Bool | isStorageManager () const
| Is the data manager a storage manager?
uInt | sequenceNr () const
| Get the (unique) sequence nr of this data manager.
uInt | ncolumn () const
| Get the nr of columns in this data manager (can be zero).
Bool | asBigEndian () const
| Have the data to be stored in big or little endian canonical format?
const TSMOption & | tsmOption () const
| Get the TSM option.
std::shared_ptr< MultiFileBase > | multiFile ()
| Get the MultiFile pointer (can be 0).
String | keywordName (const String &keyword) const
| Compose a keyword name from the given keyword appended with the sequence number (e.g.
String | fileName () const
| Compose a unique filename from the table name and sequence number.
ByteIO::OpenOption | fileOption () const
| Get the AipsIO option of the underlying file.
virtual Bool | isRegular () const
| Is this a regular storage manager?
Table & | table () const
| Get the table this object is associated with.
virtual void | reopenRW ()
| Reopen the data manager for read/write access.
virtual Bool | canRenameColumn () const
| Does the data manager allow to rename columns?
virtual void | setMaximumCacheSize (uInt nMiB)
| Set the maximum cache size (in bytes) to be used by a storage manager.
virtual void | showCacheStatistics (std::ostream &) const
| Show the data manager's IO statistics.
DataManagerColumn * | createScalarColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create a column in the data manager on behalf of a table column.
DataManagerColumn * | createDirArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create a direct array column.
DataManagerColumn * | createIndArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create an indirect array column.
DataManager * | getClone () const
| Has the object already been cloned?
void | setClone (DataManager *clone) const
| Set the pointer to the clone.

## Additional Inherited Members

Static Public Member Functions inherited from casacore::MSMBase
static DataManager * | makeObject (const String &dataManagerType, const Record &spec)
| Make the object from the string.
Static Public Member Functions inherited from casacore::DataManager
static void | registerCtor (const String &type, DataManagerCtor func)
| Register a mapping of a data manager type to its static construction function.
static DataManagerCtor | getCtor (const String &dataManagerType)
| Get the "constructor" of a data manager (thread-safe).
static Bool | isRegistered (const String &dataManagerType)
| Test if a data manager is registered (thread-safe).
static DataManager * | unknownDataManager (const String &dataManagerType, const Record &spec)
| Serve as default function for theirRegisterMap, which catches all unknown data manager types.
Static Public Attributes inherited from casacore::DataManager
static rownr_t | MAXROWNR32
| Define the highest row number that can be represented as signed 32-bit.
Protected Member Functions inherited from casacore::DataManager
void | decrementNcolumn ()
| Decrement number of columns (in case a column is deleted).
void | setEndian (Bool bigEndian)
| Tell the data manager if big or little endian format is needed.
void | setTsmOption (const TSMOption &tsmOption)
| Tell the data manager which TSM option to use.
void | setMultiFile (const std::shared_ptr< MultiFileBase > &mfile)
| Tell the data manager that MultiFile can be used.
virtual Bool | hasMultiFileSupport () const
| Does the data manager support use of MultiFile?
void | throwDataTypeOther (const String &columnName, int dataType) const
| Throw an exception in case data type is TpOther, because the storage managers (and maybe other data managers) do not support such columns.
Protected Attributes inherited from casacore::MSMBase
String | stmanName_p
| Name given by user to this storage manager.
rownr_t | nrrow_p
| The number of rows in the columns.
rownr_t | nrrowCreate_p
| The number of rows in create().
Block< MSMColumn * > | colSet_p
| The assembly of all columns.
Bool | hasPut_p
| Has anything been put since the last flush?

## Detailed Description

Memory-based table storage manager class

### Intended use:

Public interface

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Prerequisite

- DataManager
- MSMColumn

### Synopsis

MemoryStMan is a table storage manager based in memory. It holds all data in the columns in memory and deletes them when the table gets closed. It contains pointers to the underlying MSMColumn objects, which do the actual data handling.

The Memory storage manager does fully support addition and removal of rows and columns.

The primary use of this storage manager is for a memory-based table, but it can also be used for temporary columns in disk-based tables. When reopening a disk-based table, possible columns stored with MemoryStMan will be initialized to 0. An important issue is synchronizing tables containing MemoryStMan storage managers in case of concurrent access. Because its data are not stored on disk, there is no way to synchronize the data if another process changed data or added or deleted rows. If the number or rows has changed, rows will be added or deleted as needed. Row deletion will be done at the end of the table.

Definition at line 79 of file MemoryStMan.h.

## Constructor & Destructor Documentation

## MemoryStMan() [1/2]

casacore::MemoryStMan::MemoryStMan | ( |  | ) |

Create an Memory storage manager.

Its name will be blank.

## MemoryStMan() [2/2]

casacore::MemoryStMan::MemoryStMan | ( | const String & | storageManagerName | ) |

Create an Memory storage manager with the given name.

Its name can be used later in e.g. Table::addColumn to add a column to this storage manager.

## ~MemoryStMan()

casacore::MemoryStMan::~MemoryStMan | ( |  | ) |

The documentation for this class was generated from the following file:

- tables/DataMan/MemoryStMan.h